"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Resource = _interopRequireDefault(require("./Resource"));
var _ResourceCreateAllOf = _interopRequireDefault(require("./ResourceCreateAllOf"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * The ResourceCreate model module.
 * @module model/ResourceCreate
 * @version 3.1.1
 */
var ResourceCreate = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ResourceCreate</code>.
   * @alias module:model/ResourceCreate
   * @implements module:model/Resource
   * @implements module:model/ResourceCreateAllOf
   */
  function ResourceCreate() {
    _classCallCheck(this, ResourceCreate);
    _Resource["default"].initialize(this);
    _ResourceCreateAllOf["default"].initialize(this);
    ResourceCreate.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ResourceCreate, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ResourceCreate</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ResourceCreate} obj Optional instance to populate.
     * @return {module:model/ResourceCreate} The populated <code>ResourceCreate</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ResourceCreate();
        _Resource["default"].constructFromObject(data, obj);
        _ResourceCreateAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('resource_id')) {
          obj['resource_id'] = _ApiClient["default"].convertToType(data['resource_id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return ResourceCreate;
}();
/**
 * The name of the resource.
 * @member {String} name
 */
ResourceCreate.prototype['name'] = undefined;

/**
 * The ID of the linked resource.
 * @member {String} resource_id
 */
ResourceCreate.prototype['resource_id'] = undefined;

// Implement Resource interface:
/**
 * The name of the resource.
 * @member {String} name
 */
_Resource["default"].prototype['name'] = undefined;
// Implement ResourceCreateAllOf interface:
/**
 * The ID of the linked resource.
 * @member {String} resource_id
 */
_ResourceCreateAllOf["default"].prototype['resource_id'] = undefined;
var _default = ResourceCreate;
exports["default"] = _default;