"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RelationshipsForTlsCsr = _interopRequireDefault(require("./RelationshipsForTlsCsr"));
var _TlsCsrDataAttributes = _interopRequireDefault(require("./TlsCsrDataAttributes"));
var _TypeTlsCsr = _interopRequireDefault(require("./TypeTlsCsr"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * The TlsCsrData model module.
 * @module model/TlsCsrData
 * @version 3.1.1
 */
var TlsCsrData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>TlsCsrData</code>.
   * @alias module:model/TlsCsrData
   */
  function TlsCsrData() {
    _classCallCheck(this, TlsCsrData);
    TlsCsrData.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(TlsCsrData, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>TlsCsrData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/TlsCsrData} obj Optional instance to populate.
     * @return {module:model/TlsCsrData} The populated <code>TlsCsrData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new TlsCsrData();
        if (data.hasOwnProperty('type')) {
          obj['type'] = _TypeTlsCsr["default"].constructFromObject(data['type']);
        }
        if (data.hasOwnProperty('attributes')) {
          obj['attributes'] = _TlsCsrDataAttributes["default"].constructFromObject(data['attributes']);
        }
        if (data.hasOwnProperty('relationships')) {
          obj['relationships'] = _RelationshipsForTlsCsr["default"].constructFromObject(data['relationships']);
        }
      }
      return obj;
    }
  }]);
  return TlsCsrData;
}();
/**
 * @member {module:model/TypeTlsCsr} type
 */
TlsCsrData.prototype['type'] = undefined;

/**
 * @member {module:model/TlsCsrDataAttributes} attributes
 */
TlsCsrData.prototype['attributes'] = undefined;

/**
 * @member {module:model/RelationshipsForTlsCsr} relationships
 */
TlsCsrData.prototype['relationships'] = undefined;
var _default = TlsCsrData;
exports["default"] = _default;