"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * The TlsCsrDataAttributes model module.
 * @module model/TlsCsrDataAttributes
 * @version 3.1.1
 */
var TlsCsrDataAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>TlsCsrDataAttributes</code>.
   * @alias module:model/TlsCsrDataAttributes
   * @param sans {Array.<String>} Subject Altername Names - An array of one or more fully qualified domain names or public IP addresses to be secured by this certificate. Required.
   */
  function TlsCsrDataAttributes(sans) {
    _classCallCheck(this, TlsCsrDataAttributes);
    TlsCsrDataAttributes.initialize(this, sans);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(TlsCsrDataAttributes, null, [{
    key: "initialize",
    value: function initialize(obj, sans) {
      obj['sans'] = sans;
    }

    /**
     * Constructs a <code>TlsCsrDataAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/TlsCsrDataAttributes} obj Optional instance to populate.
     * @return {module:model/TlsCsrDataAttributes} The populated <code>TlsCsrDataAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new TlsCsrDataAttributes();
        if (data.hasOwnProperty('sans')) {
          obj['sans'] = _ApiClient["default"].convertToType(data['sans'], ['String']);
        }
        if (data.hasOwnProperty('common_name')) {
          obj['common_name'] = _ApiClient["default"].convertToType(data['common_name'], 'String');
        }
        if (data.hasOwnProperty('country')) {
          obj['country'] = _ApiClient["default"].convertToType(data['country'], 'String');
        }
        if (data.hasOwnProperty('state')) {
          obj['state'] = _ApiClient["default"].convertToType(data['state'], 'String');
        }
        if (data.hasOwnProperty('city')) {
          obj['city'] = _ApiClient["default"].convertToType(data['city'], 'String');
        }
        if (data.hasOwnProperty('postal_code')) {
          obj['postal_code'] = _ApiClient["default"].convertToType(data['postal_code'], 'String');
        }
        if (data.hasOwnProperty('street_address')) {
          obj['street_address'] = _ApiClient["default"].convertToType(data['street_address'], 'String');
        }
        if (data.hasOwnProperty('organization')) {
          obj['organization'] = _ApiClient["default"].convertToType(data['organization'], 'String');
        }
        if (data.hasOwnProperty('organizational_unit')) {
          obj['organizational_unit'] = _ApiClient["default"].convertToType(data['organizational_unit'], 'String');
        }
        if (data.hasOwnProperty('email')) {
          obj['email'] = _ApiClient["default"].convertToType(data['email'], 'String');
        }
      }
      return obj;
    }
  }]);
  return TlsCsrDataAttributes;
}();
/**
 * Subject Altername Names - An array of one or more fully qualified domain names or public IP addresses to be secured by this certificate. Required.
 * @member {Array.<String>} sans
 */
TlsCsrDataAttributes.prototype['sans'] = undefined;

/**
 * Common Name (CN) - The fully qualified domain name (FQDN) to be secured by this certificate. The common name should be one of the entries in the SANs parameter.
 * @member {String} common_name
 */
TlsCsrDataAttributes.prototype['common_name'] = undefined;

/**
 * Country (C) - The two-letter ISO country code where the organization is located.
 * @member {String} country
 */
TlsCsrDataAttributes.prototype['country'] = undefined;

/**
 * State (S) - The state, province, region, or county where the organization is located. This should not be abbreviated.
 * @member {String} state
 */
TlsCsrDataAttributes.prototype['state'] = undefined;

/**
 * Locality (L) - The locality, city, town, or village where the organization is located.
 * @member {String} city
 */
TlsCsrDataAttributes.prototype['city'] = undefined;

/**
 * Postal Code - The postal code where the organization is located.
 * @member {String} postal_code
 */
TlsCsrDataAttributes.prototype['postal_code'] = undefined;

/**
 * Street Address - The street address where the organization is located.
 * @member {String} street_address
 */
TlsCsrDataAttributes.prototype['street_address'] = undefined;

/**
 * Organization (O) - The legal name of the organization, including any suffixes. This should not be abbreviated.
 * @member {String} organization
 */
TlsCsrDataAttributes.prototype['organization'] = undefined;

/**
 * Organizational Unit (OU) - The internal division of the organization managing the certificate.
 * @member {String} organizational_unit
 */
TlsCsrDataAttributes.prototype['organizational_unit'] = undefined;

/**
 * Email Address (EMAIL) - The organizational contact for this.
 * @member {String} email
 */
TlsCsrDataAttributes.prototype['email'] = undefined;
var _default = TlsCsrDataAttributes;
exports["default"] = _default;